package fr.univlyon1.tiw1.inscriptions;

import fr.univlyon1.tiw1.inscriptions.modele.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;

import javax.inject.Inject;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.validation.constraints.NotNull;
import javax.xml.ws.WebFault;
import java.util.Collection;

/**
 * Created by ecoquery on 19/10/2016.
 */
@WebService(endpointInterface = "fr.univlyon1.tiw1.inscriptions.InscriptionsService", targetNamespace = Constants.SERVICE_NAMESPACE)
public class InscriptionsServiceImpl {

    private static final Logger LOG = LoggerFactory.getLogger(InscriptionsServiceImpl.class);
    private InscriptionsDAO dao;

    //@Autowired
    public void setDao(InscriptionsDAO dao) {
        this.dao = dao;
    }

    public InscriptionsDAO getDao() {
        return dao;
    }

    @Transactional
    public Person metAJourPersonne(@NotNull Person person) {
        return dao.createOrUpdate(person);
    }

    @Transactional
    public Collection<Event> evenements() {
        Collection<Event> result = dao.getAllEvents();
        for(Event evt : result) {
            evt.getEmailsInscrits();
        }
        return result;
    }

    @Transactional
    public boolean inscrire(@NotNull String email, @NotNull String titreEvenement) throws EvenementInconnuException {
        Person p = new Person();
        p.setEmail(email);
        LOG.debug("inscrire, dao: {}", dao);
        p = dao.createOrUpdate(p);
        Event e = dao.getEventByName(titreEvenement);
        p.inscrire(e);
        return true;
    }
}
